#!/bin/python3
import sys
from hamso import hamso
from hamso import dao_ham_ham_so

# lay cac tham so tu dong lenh
if (len(sys.argv)<2):
	print (" Goi ham bang lenh:")
	print ("             sys.argv[0]  a b")
	print (" Trong do a, b la hai so thuc - la khoang xac dinh nghiem can tinh")
	exit(255)
a=float(sys.argv[1])
b=float(sys.argv[2])

# mac dinh sai so la 1e-5
if (len(sys.argv)<4):
	ssyc=1e-5
else:
	ssyc=float(sys.argv[3])

# tinh ham de kiem tra khoang nghiem
(fa,ga)=hamso(a)
(fb,ga)=hamso(b)

# neu khong phai khoang nghiem thi thoat
if (fa*fb>0):
        print ("Loi: ( %f ; %f ) khong phai la khoang nghem" %(a,b))
        print ("     fa = %f, fb = %f, fa*fb>0" %(fa,fb))
        sys.exit()

# xac dinh x0
dfxa=dao_ham_ham_so(a,1e-3)
dfxb=dao_ham_ham_so(b,1e-3)
if (dfxa > dfxb):
	x0=a
else:
	x0=b

# Kiem tra dieu kien ham don dieu cua phuong phap newton
if (dfxa * dfxb < 0):
        print ("Loi: ( %f ; %f ) khong dap ung yeu cau ham don dieu cua phuong phap newton." %(a,b))
        print ("     f'(a) = %f, f'(b) = %f, khong cung dau." %(fa,fb))
        sys.exit()


# khai bao ky tu de ve bang
vien_ngang='\u2500'

# Kiem tra do lon cua khoang ngiem de in bang cho phu hop
do_lon = max(abs(a),abs(b))
i=0
while (do_lon>1):
	i+=1
	do_lon /= 10
do_lon=i+8

if (do_lon < 10):
	do_lon=10

# In tieu de bang
# In tieu de bang
print (" Bang tinh ham bang phuong phap tiep tuyen\n")
do_lon+=2
print ("\u250c%s\u252c%s\u252c%s\u252c%s\u252c%s\u2510" % \
	(vien_ngang*do_lon, vien_ngang*do_lon, vien_ngang*do_lon, vien_ngang*do_lon, vien_ngang*9))
do_lon-=2
print ("\u2502",'x0'.center(do_lon, ' '),"\u2502","f(x)".center(do_lon, ' '),"\u2502","f'(x)".center(do_lon, ' '),"\u2502", \
        "f(x)/f'(x)".center(do_lon, ' '),"\u2502",'sai so'.center(7, ' '),"\u2502")
do_lon+=2

print ("\u251c%s\u253c%s\u253c%s\u253c%s\u253c%s\u2524" % \
        (vien_ngang*do_lon, vien_ngang*do_lon, vien_ngang*do_lon, vien_ngang*do_lon, vien_ngang*9))
do_lon-=2

# Bat dau su dung phuong phap chia doi
ss = abs((a-b)/10)
# Lap, moi buoc lap tinh mot buoc cua phuong phap chia doi
while (ss>ssyc):
	# Tinh dao ham cua ham tai nghiem
	dfx0=dao_ham_ham_so(x0,ss)
	# Kiem tra lai dieu kien hoij tu
	if (dfx0 * dfxa < 0):
	        print ("Loi: ( %f ; %f ) khong dap ung yeu cau ham don dieu cua phuong phap newton." %(a,b))
        	print ("     f'(a) = %f, f'(b) = %f, khong cung dau." %(fa,fb))
        	sys.exit()

	# Tinh gia tri ham tai nghiem
	(fx,ga) = hamso(x0)
	# Tinh gia tri sai lech cua nghiem moi
	dx = fx/dfx0
	# Xac dinh sai so hien tai
	ss=abs(dx)
	# In bang ket qua
	print ("\u2502",str(f"{x0:.6f}").center(do_lon, ' '),"\u2502",str(f"{fx:.6f}").center(do_lon, ' '),"\u2502", \
                str(f"{dfx0:.6f}").center(do_lon, ' '), "\u2502",str(f"{dx:.6f}").center(do_lon, ' '),"\u2502", \
                str(f"{ss:.1e}").center(6,' '),"\u2502")

	x0=x0-dx
	print (cos(x0))
# In dong cuoi cung cua bang
print ("\u2502",str(f"{x0:.6f}").center(do_lon, ' '),"\u2502",str("--").center(do_lon, ' '),"\u2502", \
                str("--").center(do_lon, ' '), "\u2502",str("--").center(do_lon, ' '),"\u2502", \
                str(f"{ss:.1e}").center(6,' '),"\u2502")


# Xac dinh nghiem khi sai so dat yeu cau
# In vien duoi cua bang
do_lon+=2
print ("\u2514%s\u2534%s\u2534%s\u2534%s\u2534%s\u2518" % \
	(vien_ngang*do_lon, vien_ngang*do_lon, vien_ngang*do_lon, vien_ngang*do_lon, vien_ngang*9))

# In ket qua cuoi cung
print (" ")
print ("                    nghiem la: %.5f +- %.5f\n" % (x0,ss))

